'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Vue = require('vue');
var Select$1 = require('@cohensive/select-core');
var defaults = require('@cohensive/select-core/defaults');
var css = require('@emotion/css');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var Vue__default = /*#__PURE__*/_interopDefault(Vue);
var Select__default = /*#__PURE__*/_interopDefault(Select$1);

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

var selectProps = {
  autoFocus: {
    type: Boolean,
    "default": defaults.defaults.autoFocus
  },
  backspaceFocusesValue: {
    type: Boolean,
    "default": defaults.defaults.backspaceFocusesValue
  },
  backspaceRemovesValue: {
    type: Boolean,
    "default": defaults.defaults.backspaceRemovesValue
  },
  blurInputOnSelect: {
    type: Boolean,
    "default": defaults.defaults.blurInputOnSelect
  },
  captureMenuScroll: {
    type: Boolean,
    "default": defaults.defaults.captureMenuScroll
  },
  className: {
    type: String,
    "default": defaults.defaults.className
  },
  classNamePrefix: {
    type: String,
    "default": 'vue-select'
  },
  clearable: {
    type: Boolean,
    "default": defaults.defaults.clearable
  },
  clearInputOnClose: {
    type: Boolean,
    "default": defaults.defaults.clearInputOnClose
  },
  clipboardOptionProperty: {
    type: String,
    "default": defaults.defaults.clipboardOptionProperty
  },
  closeMenuOnSelect: {
    type: Boolean,
    "default": defaults.defaults.closeMenuOnSelect
  },
  closeMenuOnScroll: {
    type: [Boolean, Function],
    "default": defaults.defaults.closeMenuOnScroll
  },
  controlShouldRenderValue: {
    type: Boolean,
    "default": defaults.defaults.controlShouldRenderValue
  },
  copyOptionDelimiter: {
    type: String,
    "default": defaults.defaults.copyOptionDelimiter
  },
  creatable: {
    type: Boolean,
    "default": defaults.defaults.creatable
  },
  delimiters: {
    type: Array,
    "default": function _default() {
      return defaults.defaults.delimiters;
    }
  },
  disabeld: {
    type: Boolean,
    "default": defaults.defaults.disabeld
  },
  escapeClearsValue: {
    type: Boolean,
    "default": defaults.defaults.escapeClearsValue
  },
  formatOptionLabel: {
    type: Function,
    "default": defaults.defaults.formatOptionLabel
  },
  formatGroupLabel: {
    type: Function,
    "default": defaults.defaults.formatGroupLabel
  },
  filterOption: {
    type: Function,
    "default": defaults.defaults.filterOption
  },
  getGroupLabel: {
    type: Function,
    "default": defaults.defaults.getGroupLabel
  },
  getOptionLabel: {
    type: Function,
    "default": defaults.defaults.getOptionLabel
  },
  getOptionValue: {
    type: Function,
    "default": defaults.defaults.getOptionValue
  },
  hideSelectedOptions: {
    type: Boolean,
    "default": defaults.defaults.hideSelectedOptions
  },
  id: {
    type: String,
    "default": defaults.defaults.id
  },
  inputValue: {
    type: String,
    "default": defaults.defaults.inputValue
  },
  inputId: {
    type: String,
    "default": defaults.defaults.inputId
  },
  inputType: {
    type: String,
    "default": defaults.defaults.inputType
  },
  isOptionDisabled: {
    type: Function,
    "default": defaults.defaults.isOptionDisabled
  },
  isOptionSelected: {
    type: Function,
    "default": defaults.defaults.isOptionSelected
  },
  keyMap: {
    type: Object,
    "default": function _default() {
      return defaults.defaults.keyMap;
    }
  },
  loading: {
    type: Boolean,
    "default": defaults.defaults.loading
  },
  loadingMessage: {
    type: [String, Function],
    "default": defaults.defaults.loadingMessage
  },
  maxOptions: {
    type: Number,
    "default": defaults.defaults.maxOptions
  },
  maxValues: {
    type: Number,
    "default": defaults.defaults.maxValues
  },
  maxMenuHeight: {
    type: Number,
    "default": defaults.defaults.maxMenuHeight
  },
  menuPlacement: {
    type: String,
    "default": defaults.defaults.menuPlacement
  },
  menuPosition: {
    type: String,
    "default": defaults.defaults.menuPosition
  },
  menuShouldBlockScroll: {
    type: Boolean,
    "default": defaults.defaults.menuShouldBlockScroll
  },
  menuShouldScrollIntoView: {
    type: Boolean,
    "default": defaults.defaults.menuShouldScrollIntoView
  },
  name: {
    type: String,
    "default": defaults.defaults.name
  },
  noOptionsMessage: {
    type: [String, Function],
    "default": defaults.defaults.noOptionsMessage
  },
  minInputLength: {
    type: Number,
    "default": defaults.defaults.minInputLength
  },
  multiple: {
    type: Boolean,
    "default": defaults.defaults.multiple
  },
  options: {
    type: Array,
    "default": function _default() {
      return defaults.defaults.options;
    }
  },
  open: {
    type: Boolean,
    "default": defaults.defaults.open
  },
  onBlur: {
    type: Function,
    "default": defaults.defaults.onBlur
  },
  onChange: {
    type: Function,
    "default": defaults.defaults.onChange
  },
  onFocus: {
    type: Function,
    "default": defaults.defaults.onFocus
  },
  onInputChange: {
    type: Function,
    "default": defaults.defaults.onInputChange
  },
  onKeyDown: {
    type: Function,
    "default": defaults.defaults.onKeyDown
  },
  onMenuOpen: {
    type: Function,
    "default": defaults.defaults.onMenuOpen
  },
  onMenuClose: {
    type: Function,
    "default": defaults.defaults.onMenuClose
  },
  onMenuScrollToTop: {
    type: Function,
    "default": defaults.defaults.onMenuScrollToTop
  },
  onMenuScrollToBottom: {
    type: Function,
    "default": defaults.defaults.onMenuScrollToBottom
  },
  openMenuOnFocus: {
    type: Boolean,
    "default": defaults.defaults.openMenuOnFocus
  },
  openMenuOnClick: {
    type: Boolean,
    "default": defaults.defaults.openMenuOnClick
  },
  placeholder: {
    type: String,
    "default": defaults.defaults.placeholder
  },
  pageSize: {
    type: Number,
    "default": defaults.defaults.pageSize
  },
  rtl: {
    type: Boolean,
    "default": defaults.defaults.rtl
  },
  screenReaderStatus: {
    type: Function,
    "default": defaults.defaults.screenReaderStatus
  },
  searchable: {
    type: Boolean,
    "default": defaults.defaults.searchable
  },
  setValueOnBlur: {
    type: Boolean,
    "default": defaults.defaults.setValueOnBlur
  },
  setValueOnPaste: {
    type: Boolean,
    "default": defaults.defaults.setValueOnPaste
  },
  tailwind: {
    type: Boolean,
    "default": false
  },
  tabIndex: {
    type: String,
    "default": defaults.defaults.tabIndex
  },
  theme: {
    type: Object,
    "default": function _default() {
      return defaults.defaults.theme;
    }
  },
  value: {
    type: [Object, Array],
    "default": function _default() {
      return defaults.defaults.value;
    }
  }
};
var creatableProps = {
  allowCreateWhileLoading: {
    type: Boolean,
    "default": false
  },
  createOptionPosition: {
    type: String,
    "default": 'last'
  },
  formatCreateLabel: {
    type: Function,
    "default": defaults.defaults.formatCreateLabel
  },
  isValidNewOption: {
    type: Function,
    "default": defaults.defaults.isValidNewOption
  },
  getNewOptionData: {
    type: Function,
    "default": defaults.defaults.getNewOptionData
  },
  onCreateOption: {
    type: Function
  }
};
var asyncProps = {
  async: {
    type: Boolean,
    "default": false
  },
  cacheOptions: {
    type: Boolean,
    "default": true
  },
  defaultOptions: {
    type: [Array, Boolean]
  },
  loadOptions: {
    type: Function
  },
  isLoading: {
    type: Boolean
  }
};
var commonProps = {
  select: {
    type: Object
  },
  state: {
    type: Object
  },
  slots: {
    type: Object
  }
};
var Props = _objectSpread2(_objectSpread2(_objectSpread2({}, selectProps), creatableProps), asyncProps);

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

var _templateObject;
var loadingDotAnimations = css.keyframes(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  0%, 80%, 100% { opacity: 0; }\n  40% { opacity: 1; }\n"])));
function renderCross(h, size) {
  return h('svg', {
    attrs: {
      height: size,
      width: size,
      viewBox: "0 0 20 20",
      ariaHidden: 'true',
      focusable: false
    }
  }, [h('path', {
    attrs: {
      d: 'M14.348 14.849c-0.469 0.469-1.229 0.469-1.697 0l-2.651-3.030-2.651 3.029c-0.469 0.469-1.229 0.469-1.697 0-0.469-0.469-0.469-1.229 0-1.697l2.758-3.15-2.759-3.152c-0.469-0.469-0.469-1.228 0-1.697s1.228-0.469 1.697 0l2.652 3.031 2.651-3.031c0.469-0.469 1.228-0.469 1.697 0s0.469 1.229 0 1.697l-2.758 3.152 2.758 3.15c0.469 0.469 0.469 1.229 0 1.698z'
    }
  })]);
}

function renderLoadingDot(h, classes, delay) {
  return h('span', {
    "class": _toConsumableArray(classes).filter(function (v) {
      return v.length;
    }),
    style: {
      animation: "".concat(loadingDotAnimations, " 1s ease-in-out ").concat(delay, "ms infinite")
    }
  });
}

function renderDropdown(h, size) {
  return h('svg', {
    attrs: {
      height: size,
      width: size,
      viewBox: '0 0 20 20',
      ariaHidden: 'true',
      focusable: false
    }
  }, [h('path', {
    attrs: {
      d: 'M4.516 7.548c0.436-0.446 1.043-0.481 1.576 0l3.908 3.747 3.908-3.747c0.533-0.481 1.141-0.446 1.574 0 0.436 0.445 0.408 1.197 0 1.615-0.406 0.418-4.695 4.502-4.695 4.502-0.217 0.223-0.502 0.335-0.787 0.335s-0.57-0.112-0.789-0.335c0 0-4.287-4.084-4.695-4.502s-0.436-1.17 0-1.615z'
    }
  })]);
}

function renderLoadingIndicator(h, props) {
  var select = props.select;
  var classes = [select.getThemeClass('loadingIndicator'), select.getClass('loading-indicator')];
  var loadingClasses = [select.getThemeClass('loadingIndicatorDot'), select.getClass('loading-indicator-dot')];
  var children = [];

  if (props.slots['loading-indicator']) {
    children = [props.slots['loading-indicator']({
      props: props
    })];
  } else {
    children = [renderLoadingDot(h, loadingClasses, 0), renderLoadingDot(h, loadingClasses, 160), renderLoadingDot(h, loadingClasses, 320)];
  }

  return h('div', {
    "class": [].concat(classes).filter(function (v) {
      return v.length;
    })
  }, [children]);
}

function renderClearIndicator(h, props) {
  var select = props.select;
  var classes = [select.getThemeClass('clearIndicator', {
    focused: select.state.isFocused
  }), select.getClass('clear-indicator')];

  if (select.state.isFocused) {
    classes.push(select.getClass('clear-indicator--is-focused'));
  }

  var child = props.slots['clear-indicator'] ? props.slots['clear-indicator']({
    props: props
  }) : renderCross(h, 20);
  return h('div', {
    "class": [].concat(classes).filter(function (v) {
      return v.length;
    }),
    on: {
      mousedown: function mousedown(e) {
        select.onClearIndicatorMouseDown(e);
      },
      touchend: function touchend(e) {
        select.onClearIndicatorTouchEnd(e);
      }
    }
  }, [child]);
}

function renderIndicatorSeparator(h, props) {
  var select = props.select;
  var classes = [select.getThemeClass('indicatorSeparator'), select.getClass('indicator-separator')];
  return h('div', {
    "class": [].concat(classes).filter(function (v) {
      return v.length;
    })
  });
}

function renderDropdownIndicator(h, props) {
  var select = props.select;
  var classes = [select.getThemeClass('dropdownIndicator', {
    focused: select.state.isFocused
  }), select.getClass('dropdown-indicator')];

  if (select.state.isFocused) {
    classes.push(select.getClass('dropdown-indicator--is-focused'));
  }

  var child = props.slots['dropdown-indicator'] ? props.slots['dropdown-indicator']({
    props: props
  }) : renderDropdown(h, 20);
  return h('div', {
    "class": [].concat(classes).filter(function (v) {
      return v.length;
    }),
    on: {
      mousedown: function mousedown(e) {
        select.onDropdownIndicatorMouseDown(e);
      },
      touchend: function touchend(e) {
        select.onDropdownIndicatorTouchEnd(e);
      }
    }
  }, [child]);
}

var Indicators = {
  name: 'Indicators',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select;
    var clearable = select.props.clearable;
    var _select$state = select.state,
        value = _select$state.value,
        isLoading = _select$state.isLoading;
    var classes = [select.getThemeClass('indicators'), select.getClass('indicators')];
    var children = [isLoading ? renderLoadingIndicator(h, props) : null, value.length && clearable ? renderClearIndicator(h, props) : null, renderIndicatorSeparator(h, props), renderDropdownIndicator(h, props)];
    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      })
    }, [children]);
  }
};

var Placeholder = {
  name: 'Placeholder',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select;
    var classes = [select.getThemeClass('placeholder'), select.getClass('placeholder')];
    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      })
    }, select.props.placeholder);
  }
};

var Value = {
  name: 'Value',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select,
        slots = props.slots,
        option = props.option,
        id = props.id;
    var multiple = select.props.multiple;
    var themeClassName = multiple ? 'multipleValue' : 'value';
    var className = multiple ? 'multiple-value' : 'value';
    var isFocused = select.getFocusedValue().indexOf(option) >= 0;
    var classes = [select.getThemeClass(themeClassName, {
      value: option
    }), select.getClass(className)];

    if (multiple && isFocused) {
      classes.push('multiple-value--is-focused');
    }

    var label = slots['value-label'] ? slots['value-label']({
      props: props
    }) : select.formatOptionLabel(option, 'control');
    var remove = slots['value-remove'] ? slots['value-remove']({
      props: props
    }) : renderCross(h, 14);

    if (multiple) {
      return h('div', {
        key: id,
        "class": classes,
        on: {
          mousedown: function mousedown(e) {
            select.onValueMouseDown(e, option);
          },
          click: function click(e) {
            select.focusValue(option, e.shiftKey, e.ctrlKey || e.shiftKey);
          }
        }
      }, [h('div', {
        "class": [select.getThemeClass('multipleValueLabel', {
          value: option
        }), select.getClass('multiple-value-label')]
      }, [label]), h('button', {
        "class": [select.getThemeClass('multipleValueRemove', {
          value: option
        }), select.getClass('multiple-value-remove')],
        on: {
          click: function click() {
            select.removeValue(option);
          }
        }
      }, [remove])]);
    }

    return h('div', {
      key: id,
      "class": classes
    }, [label]);
  }
};

var Typehead = Vue__default["default"].extend({
  name: 'Typehead',
  props: commonProps,
  watch: {
    'select.state.isFocused': {
      handler: function handler(value) {
        if (value) this.$el.focus();
      }
    },
    'select.state.inputValue': {
      handler: function handler(value) {
        this.$el.value = value;
      }
    }
  },
  mounted: function mounted() {
    this.select.setInputRef(this.$el);
  },
  render: function render(h) {
    var select = this.select;
    var classes = [select.getThemeClass('input'), select.getClass('input')];
    return h('input', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      }),
      style: {
        minWidth: '2px',
        opacity: select.state.inputIsHidden ? 0 : null
      },
      attrs: {
        type: select.props.inputType,
        value: select.state.inputValue,
        spellcheck: false,
        tabindex: 0
      },
      on: {
        keydown: function keydown(e) {
          select.onKeyDown(e);
        },
        input: function input(e) {
          select.handleInputChange(e);
        },
        paste: function paste(e) {
          if (select.props.multiple && select.props.setValueOnPaste) {
            select.pasteValue(e);
          }
        },
        mousedown: function mousedown(e) {
          e.stopPropagation();
        },
        focus: function focus(e) {
          select.onInputFocus(e);
        },
        blur: function blur(e) {
          select.onInputBlur(e);
        }
      }
    });
  }
});

var ValueContainer = {
  name: 'ValueContainer',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select,
        state = props.state;
    var value = state.value,
        inputValue = state.inputValue;
    var multiple = select.props.multiple;
    var children = [];

    if (value.length && !inputValue || value.length && multiple) {
      value.forEach(function (option, i) {
        children.push(h(Value, {
          props: _objectSpread2(_objectSpread2({}, props), {}, {
            option: option,
            id: "".concat(i)
          })
        }));
      });
    } else if (!inputValue) {
      children.push(h(Placeholder, {
        key: 'placeholder',
        props: props
      }));
    }

    children.push(h('div', {
      key: 'inputContainer',
      "class": [select.getThemeClass('inputContainer'), select.getClass('input-container')],
      style: {
        gridTemplateColumns: '0px min-content'
      }
    }, [h(Typehead, {
      props: props
    }), h('div', {
      "class": [select.getThemeClass('inputSizer'), select.getClass('input-sizer')]
    }, state.inputValue)]));
    var classes = [select.getThemeClass('valueContainer'), select.getClass('value-container')];

    if (multiple && value.length) {
      classes = [select.getThemeClass('multipleValueContainer'), select.getClass('multiple-value-container')];
    }

    return h('div', {
      "class": _toConsumableArray(classes).filter(function (v) {
        return v.length;
      })
    }, children);
  }
};

var Control = Vue__default["default"].extend({
  name: 'Control',
  props: commonProps,
  mounted: function mounted() {
    this.select.setControlRef(this.$el);
  },
  render: function render(h) {
    var select = this.select;
    var state = this.state;
    var props = this.$props;
    var classes = [select.getThemeClass('control', {
      focused: state.isFocused,
      open: state.isOpen
    }), select.getClass('control')];

    if (state.isFocused) {
      classes.push(select.getClass('control--is-focused'));
    }

    if (state.isOpen) {
      classes.push(select.getClass('control--menu-is-open'));
    }

    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      }),
      on: {
        mousedown: function mousedown(e) {
          select.onControlMouseDown(e);
        }
      }
    }, [h(ValueContainer, {
      props: props
    }), h(Indicators, {
      props: props
    })]);
  }
});

var Group = {
  name: 'Group',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select,
        slots = props.slots,
        group = props.group,
        children = props.children;
    var classes = [select.getThemeClass('group'), select.getClass('group')];
    var labelClasses = [select.getThemeClass('groupLabel'), select.getClass('group-label')];
    var groupId = "".concat(select.getElementId('group'), "-").concat(group.index);
    var label = slots['group'] ? slots['group']({
      props: props
    }) : select.formatGroupLabel(group.data);
    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      }),
      attrs: {
        id: groupId
      },
      key: groupId
    }, [h('div', {
      "class": [].concat(labelClasses).filter(function (v) {
        return v.length;
      })
    }, [label]), h('div', {}, [children])]);
  }
};

var Option = Vue__default["default"].extend({
  name: 'Option',
  props: {
    select: Object,
    slots: Object,
    option: Object,
    selected: Boolean,
    focused: Boolean,
    id: String
  },
  updated: function updated() {
    if (this.$props.focused) {
      this.$props.select.setFocusedOptionRef(this.$el);
      this.$props.select.updated();
    }
  },
  render: function render(h) {
    var _this$$props = this.$props,
        select = _this$$props.select,
        option = _this$$props.option,
        selected = _this$$props.selected,
        focused = _this$$props.focused,
        id = _this$$props.id;
    var classes = [select.getThemeClass('option', {
      option: option,
      selected: selected,
      focused: focused
    }), select.getClass('option')];

    if (option.disabled) {
      classes.push(select.getClass('option--is-disabled'));
    }

    if (focused) {
      classes.push(select.getClass('option--is-focused'));
    }

    var optionId = "".concat(select.getElementId('option'), "-").concat(id);
    var events = {};

    if (!option.disabled) {
      var onHover = function onHover() {
        return select.onOptionHover(option.data);
      };

      events.click = function () {
        return select.selectOption(option.data);
      };

      events.mousemove = onHover;
      events.mouseover = onHover;
    }

    var child = this.slots['option'] ? this.slots['option']({
      props: this.$props
    }) : select.formatOptionLabel(option.data, 'menu');
    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      }),
      attrs: {
        id: optionId,
        tabIndex: -1
      },
      on: events
    }, [child]);
  }
});

var Menu = Vue__default["default"].extend({
  name: 'Menu',
  props: _objectSpread2(_objectSpread2({}, commonProps), {}, {
    options: Array
  }),
  mounted: function mounted() {
    this.select.setMenuListRef(this.$el);
  },
  render: function render(h) {
    var _this = this;

    var _this$$props = this.$props,
        select = _this$$props.select,
        options = _this$$props.options;
    var value = select.getValue();
    var focusedOption = select.getFocusedOption();
    var children = [];
    var classes = [select.getThemeClass('menu'), select.getClass('menu')];

    var renderOption = function renderOption(option, id) {
      var focused = focusedOption && focusedOption.value === option.value;
      var selected = value.indexOf(option.data) >= 0;
      var el = h(Option, {
        props: _objectSpread2(_objectSpread2({}, _this.$props), {}, {
          option: option,
          selected: selected,
          focused: focused,
          id: id,
          key: id
        })
      });
      return el;
    };

    var renderGroup = function renderGroup(group) {
      var options = group.options.map(function (option) {
        return renderOption(option, "".concat(group.index, "-").concat(option.index));
      });
      return h(Group, {
        props: _objectSpread2(_objectSpread2({}, _this.$props), {}, {
          group: group,
          children: options
        })
      });
    };

    options.forEach(function (item) {
      if (item.type === 'group') {
        children.push(renderGroup(item));
      } else {
        children.push(renderOption(item, "".concat(item.index)));
      }
    });

    if (!children.length) {
      children.push(h('div', {
        "class": [select.getThemeClass('noOptionsMessage')]
      }, select.props.noOptionsMessage));
    }

    return h('div', {
      "class": [].concat(classes).filter(function (v) {
        return v.length;
      }),
      style: {
        maxHeight: "".concat(select.props.maxMenuHeight, "px")
      },
      on: {
        mousedown: function mousedown(e) {
          select.onMenuMouseDown(e);
        },
        mousemove: function mousemove(e) {
          select.onMenuMouseMove(e);
        }
      }
    }, children);
  }
});

var Container = {
  name: 'Container',
  functional: true,
  render: function render(h, _ref) {
    var props = _ref.props;
    var select = props.select,
        state = props.state;
    var options = select.getSelectOptions();
    var children = [h(Control, {
      props: props
    })];

    if (state.isOpen && options.length) {
      children.push(h(Menu, {
        props: _objectSpread2(_objectSpread2({}, props), {}, {
          options: options
        })
      }));
    }

    return h('div', {
      "class": [select.getThemeClass('container'), select.getClass('container')]
    }, children);
  }
};

var Select = Vue__default["default"].extend({
  name: 'Select',
  props: Props,
  data: function data() {
    var props = this.$props;

    if (props.tailwind) {
      props.theme = Select$1.theme;
    }

    return {
      select: new Select__default["default"](props)
    };
  },
  watch: {
    $props: {
      handler: function handler(n, p) {
        this.select.setProps(this.$props);
      },
      deep: true,
      immediate: true
    }
  },
  mounted: function mounted() {
    var _this = this;

    var select = this.select;

    if (select.props.autoFocus) {
      select.focus();
    }

    select.startListeningComposition();
    select.startListeningToTouch();
    select.on('change', function (newValue) {
      _this.$emit('update:value', _toConsumableArray(newValue));
    });

    if (select.props.closeMenuOnScroll && document && document.addEventListener) {
      // Listen to all scroll events, and filter them out inside of 'onScroll'
      document.addEventListener('scroll', select.onScroll, true);
    }

    if (select.props.autoFocus) {
      select.focusInput();
    }
  },
  render: function render(h) {
    return h('div', [h(Container, {
      props: {
        select: this.select,
        state: this.select.state,
        slots: this.$scopedSlots
      }
    })]);
  }
});

exports.Select = Select;
