export declare const selectProps: {
    autoFocus: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    backspaceFocusesValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    backspaceRemovesValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    blurInputOnSelect: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    captureMenuScroll: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    className: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    classNamePrefix: {
        type: StringConstructor;
        default: string;
    };
    clearable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    clearInputOnClose: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    clipboardOptionProperty: {
        type: StringConstructor;
        default: string | undefined;
    };
    closeMenuOnSelect: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    closeMenuOnScroll: {
        type: (BooleanConstructor | FunctionConstructor)[];
        default: boolean | import("@cohensive/select-core/types").ScrollHandler | undefined;
    };
    controlShouldRenderValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    copyOptionDelimiter: {
        type: StringConstructor;
        default: string | undefined;
    };
    creatable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    delimiters: {
        type: ArrayConstructor;
        default: () => string[] | undefined;
    };
    disabeld: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    escapeClearsValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    formatOptionLabel: {
        type: FunctionConstructor;
        default: ((option: import("@cohensive/select-core/types").Option, formatOptionLabelMeta: import("@cohensive/select-core/types").FormatOptionLabelMeta) => any) | null | undefined;
    };
    formatGroupLabel: {
        type: FunctionConstructor;
        default: ((group: import("@cohensive/select-core/types").Group) => any) | null | undefined;
    };
    filterOption: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").FilterOption | null | undefined;
    };
    getGroupLabel: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetGroupLabel | undefined;
    };
    getOptionLabel: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetOptionLabel<import("@cohensive/select-core/types").Option> | undefined;
    };
    getOptionValue: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetOptionValue<import("@cohensive/select-core/types").Option> | undefined;
    };
    hideSelectedOptions: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    id: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    inputValue: {
        type: StringConstructor;
        default: string | undefined;
    };
    inputId: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    inputType: {
        type: StringConstructor;
        default: string | undefined;
    };
    isOptionDisabled: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").IsOptionDisabled | undefined;
    };
    isOptionSelected: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").IsOptionSelected | null | undefined;
    };
    keyMap: {
        type: ObjectConstructor;
        default: () => {
            [key: string]: string;
        } | undefined;
    };
    loading: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    loadingMessage: {
        type: (StringConstructor | FunctionConstructor)[];
        default: import("@cohensive/select-core/types").LoadingMessage | undefined;
    };
    maxOptions: {
        type: NumberConstructor;
        default: number | undefined;
    };
    maxValues: {
        type: NumberConstructor;
        default: number | undefined;
    };
    maxMenuHeight: {
        type: NumberConstructor;
        default: number | undefined;
    };
    menuPlacement: {
        type: StringConstructor;
        default: import("@cohensive/select-core/types").MenuPlacement | undefined;
    };
    menuPosition: {
        type: StringConstructor;
        default: import("@cohensive/select-core/types").MenuPosition | undefined;
    };
    menuShouldBlockScroll: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    menuShouldScrollIntoView: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    name: {
        type: StringConstructor;
        default: string | undefined;
    };
    noOptionsMessage: {
        type: (StringConstructor | FunctionConstructor)[];
        default: string | (() => string) | undefined;
    };
    minInputLength: {
        type: NumberConstructor;
        default: number | undefined;
    };
    multiple: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    options: {
        type: ArrayConstructor;
        default: () => import("@cohensive/select-core/types").OptionsOrGroups | undefined;
    };
    open: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    onBlur: {
        type: FunctionConstructor;
        default: ((event: FocusEvent) => void) | undefined;
    };
    onChange: {
        type: FunctionConstructor;
        default: ((newValue: import("@cohensive/select-core/types").Options, actionMeta: import("@cohensive/select-core/types").ActionMeta) => void) | undefined;
    };
    onFocus: {
        type: FunctionConstructor;
        default: ((event: FocusEvent) => void) | undefined;
    };
    onInputChange: {
        type: FunctionConstructor;
        default: ((newValue: string, actionMeta: import("@cohensive/select-core/types").InputActionMeta) => void) | undefined;
    };
    onKeyDown: {
        type: FunctionConstructor;
        default: ((event: KeyboardEvent) => void) | undefined;
    };
    onMenuOpen: {
        type: FunctionConstructor;
        default: (() => void) | undefined;
    };
    onMenuClose: {
        type: FunctionConstructor;
        default: (() => void) | undefined;
    };
    onMenuScrollToTop: {
        type: FunctionConstructor;
        default: ((event: WheelEvent | TouchEvent) => void) | undefined;
    };
    onMenuScrollToBottom: {
        type: FunctionConstructor;
        default: ((event: WheelEvent | TouchEvent) => void) | undefined;
    };
    openMenuOnFocus: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    openMenuOnClick: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    placeholder: {
        type: StringConstructor;
        default: string | undefined;
    };
    pageSize: {
        type: NumberConstructor;
        default: number | undefined;
    };
    rtl: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    screenReaderStatus: {
        type: FunctionConstructor;
        default: (({ count }: {
            count: number;
        }) => string) | undefined;
    };
    searchable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    setValueOnBlur: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    setValueOnPaste: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    tailwind: {
        type: BooleanConstructor;
        default: boolean;
    };
    tabIndex: {
        type: StringConstructor;
        default: string | undefined;
    };
    theme: {
        type: ObjectConstructor;
        default: () => import("@cohensive/select-core/types").Theme | null | undefined;
    };
    value: {
        type: (ArrayConstructor | ObjectConstructor)[];
        default: () => import("@cohensive/select-core/types").Options | undefined;
    };
};
export declare const creatableProps: {
    allowCreateWhileLoading: {
        type: BooleanConstructor;
        default: boolean;
    };
    createOptionPosition: {
        type: StringConstructor;
        default: string;
    };
    formatCreateLabel: {
        type: FunctionConstructor;
        default: ((inputValue: string) => string) | undefined;
    };
    isValidNewOption: {
        type: FunctionConstructor;
        default: ((inputValue: string, value: import("@cohensive/select-core/types").Options, options: import("@cohensive/select-core/types").Options, accessors: import("@cohensive/select-core/types").Accessors<import("@cohensive/select-core/types").Option>) => boolean) | undefined;
    };
    getNewOptionData: {
        type: FunctionConstructor;
        default: ((inputValue: string, optionLabel: string) => import("@cohensive/select-core/types").Option) | undefined;
    };
    onCreateOption: {
        type: FunctionConstructor;
    };
};
export declare const asyncProps: {
    async: {
        type: BooleanConstructor;
        default: boolean;
    };
    cacheOptions: {
        type: BooleanConstructor;
        default: boolean;
    };
    defaultOptions: {
        type: (BooleanConstructor | ArrayConstructor)[];
    };
    loadOptions: {
        type: FunctionConstructor;
    };
    isLoading: {
        type: BooleanConstructor;
    };
};
export declare const commonProps: {
    select: {
        type: ObjectConstructor;
    };
    state: {
        type: ObjectConstructor;
    };
    slots: {
        type: ObjectConstructor;
    };
};
export declare const selectCommonProps: {
    clearValue: {
        type: FunctionConstructor;
    };
    getValue: {
        type: FunctionConstructor;
    };
    getFocusedValue: {
        type: FunctionConstructor;
    };
    getFocusedOption: {
        type: FunctionConstructor;
    };
    getElementId: {
        type: FunctionConstructor;
    };
    getThemeClass: {
        type: FunctionConstructor;
    };
    getClass: {
        type: FunctionConstructor;
    };
    getState: {
        type: FunctionConstructor;
    };
    hasValue: {
        type: BooleanConstructor;
    };
    multiple: {
        type: BooleanConstructor;
    };
    rtl: {
        type: BooleanConstructor;
    };
    options: {
        type: ArrayConstructor;
    };
    selectOption: {
        type: FunctionConstructor;
    };
    selectProps: {
        type: ObjectConstructor;
    };
    setValue: {
        type: FunctionConstructor;
    };
};
declare const _default: {
    async: {
        type: BooleanConstructor;
        default: boolean;
    };
    cacheOptions: {
        type: BooleanConstructor;
        default: boolean;
    };
    defaultOptions: {
        type: (BooleanConstructor | ArrayConstructor)[];
    };
    loadOptions: {
        type: FunctionConstructor;
    };
    isLoading: {
        type: BooleanConstructor;
    };
    allowCreateWhileLoading: {
        type: BooleanConstructor;
        default: boolean;
    };
    createOptionPosition: {
        type: StringConstructor;
        default: string;
    };
    formatCreateLabel: {
        type: FunctionConstructor;
        default: ((inputValue: string) => string) | undefined;
    };
    isValidNewOption: {
        type: FunctionConstructor;
        default: ((inputValue: string, value: import("@cohensive/select-core/types").Options, options: import("@cohensive/select-core/types").Options, accessors: import("@cohensive/select-core/types").Accessors<import("@cohensive/select-core/types").Option>) => boolean) | undefined;
    };
    getNewOptionData: {
        type: FunctionConstructor;
        default: ((inputValue: string, optionLabel: string) => import("@cohensive/select-core/types").Option) | undefined;
    };
    onCreateOption: {
        type: FunctionConstructor;
    };
    autoFocus: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    backspaceFocusesValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    backspaceRemovesValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    blurInputOnSelect: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    captureMenuScroll: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    className: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    classNamePrefix: {
        type: StringConstructor;
        default: string;
    };
    clearable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    clearInputOnClose: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    clipboardOptionProperty: {
        type: StringConstructor;
        default: string | undefined;
    };
    closeMenuOnSelect: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    closeMenuOnScroll: {
        type: (BooleanConstructor | FunctionConstructor)[];
        default: boolean | import("@cohensive/select-core/types").ScrollHandler | undefined;
    };
    controlShouldRenderValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    copyOptionDelimiter: {
        type: StringConstructor;
        default: string | undefined;
    };
    creatable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    delimiters: {
        type: ArrayConstructor;
        default: () => string[] | undefined;
    };
    disabeld: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    escapeClearsValue: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    formatOptionLabel: {
        type: FunctionConstructor;
        default: ((option: import("@cohensive/select-core/types").Option, formatOptionLabelMeta: import("@cohensive/select-core/types").FormatOptionLabelMeta) => any) | null | undefined;
    };
    formatGroupLabel: {
        type: FunctionConstructor;
        default: ((group: import("@cohensive/select-core/types").Group) => any) | null | undefined;
    };
    filterOption: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").FilterOption | null | undefined;
    };
    getGroupLabel: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetGroupLabel | undefined;
    };
    getOptionLabel: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetOptionLabel<import("@cohensive/select-core/types").Option> | undefined;
    };
    getOptionValue: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").GetOptionValue<import("@cohensive/select-core/types").Option> | undefined;
    };
    hideSelectedOptions: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    id: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    inputValue: {
        type: StringConstructor;
        default: string | undefined;
    };
    inputId: {
        type: StringConstructor;
        default: string | null | undefined;
    };
    inputType: {
        type: StringConstructor;
        default: string | undefined;
    };
    isOptionDisabled: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").IsOptionDisabled | undefined;
    };
    isOptionSelected: {
        type: FunctionConstructor;
        default: import("@cohensive/select-core/types").IsOptionSelected | null | undefined;
    };
    keyMap: {
        type: ObjectConstructor;
        default: () => {
            [key: string]: string;
        } | undefined;
    };
    loading: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    loadingMessage: {
        type: (StringConstructor | FunctionConstructor)[];
        default: import("@cohensive/select-core/types").LoadingMessage | undefined;
    };
    maxOptions: {
        type: NumberConstructor;
        default: number | undefined;
    };
    maxValues: {
        type: NumberConstructor;
        default: number | undefined;
    };
    maxMenuHeight: {
        type: NumberConstructor;
        default: number | undefined;
    };
    menuPlacement: {
        type: StringConstructor;
        default: import("@cohensive/select-core/types").MenuPlacement | undefined;
    };
    menuPosition: {
        type: StringConstructor;
        default: import("@cohensive/select-core/types").MenuPosition | undefined;
    };
    menuShouldBlockScroll: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    menuShouldScrollIntoView: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    name: {
        type: StringConstructor;
        default: string | undefined;
    };
    noOptionsMessage: {
        type: (StringConstructor | FunctionConstructor)[];
        default: string | (() => string) | undefined;
    };
    minInputLength: {
        type: NumberConstructor;
        default: number | undefined;
    };
    multiple: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    options: {
        type: ArrayConstructor;
        default: () => import("@cohensive/select-core/types").OptionsOrGroups | undefined;
    };
    open: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    onBlur: {
        type: FunctionConstructor;
        default: ((event: FocusEvent) => void) | undefined;
    };
    onChange: {
        type: FunctionConstructor;
        default: ((newValue: import("@cohensive/select-core/types").Options, actionMeta: import("@cohensive/select-core/types").ActionMeta) => void) | undefined;
    };
    onFocus: {
        type: FunctionConstructor;
        default: ((event: FocusEvent) => void) | undefined;
    };
    onInputChange: {
        type: FunctionConstructor;
        default: ((newValue: string, actionMeta: import("@cohensive/select-core/types").InputActionMeta) => void) | undefined;
    };
    onKeyDown: {
        type: FunctionConstructor;
        default: ((event: KeyboardEvent) => void) | undefined;
    };
    onMenuOpen: {
        type: FunctionConstructor;
        default: (() => void) | undefined;
    };
    onMenuClose: {
        type: FunctionConstructor;
        default: (() => void) | undefined;
    };
    onMenuScrollToTop: {
        type: FunctionConstructor;
        default: ((event: WheelEvent | TouchEvent) => void) | undefined;
    };
    onMenuScrollToBottom: {
        type: FunctionConstructor;
        default: ((event: WheelEvent | TouchEvent) => void) | undefined;
    };
    openMenuOnFocus: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    openMenuOnClick: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    placeholder: {
        type: StringConstructor;
        default: string | undefined;
    };
    pageSize: {
        type: NumberConstructor;
        default: number | undefined;
    };
    rtl: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    screenReaderStatus: {
        type: FunctionConstructor;
        default: (({ count }: {
            count: number;
        }) => string) | undefined;
    };
    searchable: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    setValueOnBlur: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    setValueOnPaste: {
        type: BooleanConstructor;
        default: boolean | undefined;
    };
    tailwind: {
        type: BooleanConstructor;
        default: boolean;
    };
    tabIndex: {
        type: StringConstructor;
        default: string | undefined;
    };
    theme: {
        type: ObjectConstructor;
        default: () => import("@cohensive/select-core/types").Theme | null | undefined;
    };
    value: {
        type: (ArrayConstructor | ObjectConstructor)[];
        default: () => import("@cohensive/select-core/types").Options | undefined;
    };
};
export default _default;
